;   ***** pcmouse_asm V1.01 *****                         12.02.92 Jo
;   + MS_RESET + SER_RESET + BAUDRATE (ausgeklinkt)

          errors    scr
          data      0

version   equ       '1.01'
; ----------------------------------------------------
; Pointer Device
; ==============
pt_xicnt equ    $2e   w count of external interrupts

pt_npos  equ    $38   l new position (set by poll)
pt_nxpos equ    $38   w new x position
pt_nypos equ    $3a   w new y position
pt_pos   equ    $3c   l current position
pt_xpos  equ    $3c   w
pt_ypos  equ    $3e   w
pt_inc   equ    $40   l positional increment
pt_xinc  equ    $40   w
pt_yinc  equ    $42   w

pt_liodm equ    $70     dummy IO linkage (initial open)
pt_aiodm equ    $74     dummy IO entry point
pt_aopdm equ    $78     dummy OPEN (standard console, modifed)
pt_acldm equ    $7c     dummy CLOSE (unlinked console)

pt_lstuf equ    $8c  b  last button press for stuffer
pt_stuf1 equ    $8d  b  first character to stuff
pt_stuf2 equ    $8e  b  second character to stuff

pt_kypol equ    $af  b  keys detected on poll
; --------------------------------------------------------
; Mouse driver
; ===========
ms_count  equ       $00       ; word counter
ms_shwert equ       $02       ; word counter value
ms_anz_x  equ       $04
ms_anz_y  equ       $06
ms_lpoll  equ       $08
ms_lschd  equ       $10
ms_point  equ       $1C       ; Pointer to Pointer Device
ms_killc  equ       $18+$0C   ; =$24 reserved !!!
ms_akt_x  equ       $28
ms_akt_y  equ       $2A
ms_div_x  equ       $2C
ms_div_y  equ       $2E
ms_sig_x  equ       $30
ms_sig_y  equ       $32
ms_downc  equ       $34

ms_pend   equ       $3F
ms_heap   equ       $40       ; Lnge heap pc-mouse driver
;---------------------------------------------------------
          bra.s     ms_ini
copyr     dc.w      32
          dc.b      'PC Mouse Driver  V'
          dc.l      version
          dc.b      ' 1992 Jo',$0A
          dc.b      '1202'
ms_ini
          lea       copyr(pc),a1
          bsr       ms_mtext
          bsr       svbase              ; SV_BASE -> a5
          lea       conname(pc),a0
          bsr       ms_open
            bne     ms_exit
          move.l    a0,d2
          swap      d2                  ; d2.w ch-tag
          movea.l   $78(a5),a1          ; SV_CHBAS
ms_chloop
          movea.l   (a1)+,a2
          cmp.w     $10(a2),d2
            beq.s   ms_chnf
          cmp.l     $7C(a5),a1
            blt.s   ms_chloop
          moveq     #-7,d0    ; ERR_NF
          bra     ms_close
ms_chnf
          moveq     #-1,d3              ; timeout
          moveq     #$70,d0   ; IOP_PINF
          trap      #3
          tst.l     d0
            bne.s   err_m1
          movea.l   4(a2),a2            ; address of driver found
          lea       -$18(a2),a4         ; address of pointer device
          bsr     ms_close

          moveq     #ms_heap,d1         ; z.B. $40 bytes
          moveq     #-1,d2              ; me
          moveq     #$18,d0   ; MT_ALCHP
          trap      #1
          tst.l     d0
            bne.s   ms_exit
          movea.l   a0,a3               ; base of mouse heap
          move.l    a4,ms_point(a3)     ; Zeiger auf Pointer Device

          lea       sername(pc),a0
          bsr.s     ms_open
            bne.s   ms_exit
          move.w    serbaud(pc),d1
          moveq     #$12,d0   ; MT_BAUD
          trap      #1
; bitte nicht stren
          move      sr,d7
          trap      #0
          ori.w     #$0700,sr
; pc mouse poll link in
          lea       ms_poll(pc),a2
          move.l    a2,ms_lpoll+4(a3)
          lea       ms_lpoll(a3),a0
          moveq     #$1C,d0   ; MT_LPOLL
          trap      #1
; pc mouse scheduler link in
          lea       ms_schd(pc),a2
          move.l    a2,ms_lschd+4(a3)
          lea       ms_lschd(a3),a0
          moveq     #$1E,d0   ; MT_LSCHD
          trap      #1
; ser poll suchen
          movea.l   $3C(a5),a1          ; SV_PLIST
          move.l    #$4000,d1           ; MG-ROM unten
ms_ploop
          move.l    (a1),d6
            beq.s   ms_link
          movea.l   d6,a1
          cmp.l     4(a1),d1
            blt.s   ms_ploop
; ser poll nach oben ziehen
ms_link
          movea.l   d6,a0
          moveq     #$1D,d0   ; MT_RPOLL
          trap      #1
          movea.l   d6,a0
          moveq     #$1C,d0   ; MT_LPOLL
          trap      #1
; fertig
          move      d7,sr
          moveq     #0,d0
          bra.s     ms_exit
;-          bra       reset_ini
err_m1
          lea       pinf_txt(pc),a1
          bsr.s     ms_mtext
          bra.s     ms_close
err_m2
          lea       mouse_txt(pc),a1
          bsr.s     ms_mtext
ms_close
          move.l    d0,d4
          moveq     #2,d0     ; IO_CLOSE
          trap      #2
          move.l    d4,d0
ms_exit
          rts
ms_open
          moveq     #-1,d1              ; me
          moveq     #0,d3               ; open_old
          moveq     #1,d0     ; IO_OPEN
          trap      #2
          tst.l     d0
          rts
ms_mtext
          move      sr,d7
          trap      #0
          ori.w     #$0700,sr
          move.l    a0,-(a7)
          suba.l    a0,a0
          movea.w   $D0,a2    ; UT_MTEXT
          jsr       (a2)
          movea.l   (a7)+,a0
          move      d7,sr
ms_rts    rts

; +++++++++++++++++++++++++++++++++++++++++++++++++
;pl_qset
;          moveq     #0,d0
;          bra.s     pl_qall
;pl_qtest
;          moveq     #2,d0
;          bra.s     pl_qall
pl_qin
          moveq     #4,d0
          bra.s     pl_qall
pl_qout
          moveq     #6,d0
;          bra.s     pl_qall
;pl_qeof
;          moveq     #8,d0
;          bra.s     pl_qall
pl_qall
          move.l    a3,-(a7)
          movea.w   d0,a3
          movea.w   $DC(a3),a3
          jsr       (a3)
          movea.l   (a7)+,a3
          tst.l     d0
          rts                           ; d1.b next byte from queue

pl_trans  dc.b      $01,$01,$FF,$01,$03,$03,$02,$00

; Mouse Polling Routine
ms_poll
          moveq     #0,d0
          move.w    (a3),d0             ; ms_count = $00
          move.l    d0,(a3)             ; reset scheduler counter
          move.w    sernum(pc),d0
          movea.l   0(a6,d0.w),a2       ; SV_SER2C $9C oder SV_SER1C $98
          bsr.s     pl_qout
            bne.s   ms_rts
          moveq     #$F8,d0
          and.b     d1,d0
          cmpi.b    #$80,d0
            bne.s   ms_rts
          st        ms_pend(a3)
; mouse buttons
          movea.l   ms_point(a3),a5
          moveq     #7,d0
          and.b     d1,d0
          move.b    pl_trans(pc,d0.w),d2
            bpl.s   pl_kypol
; mouse hotkey
          tas       pt_lstuf(a5)
            blt.s   ms_rts
          move.l    a2,d3               ; a2 Zeiger auf ser queue retten
          movea.l   $004C(a6),a2        ; SV_KEYQ
          move.b    pt_stuf1(a5),d1
            beq.s   pl_stfok
          bsr.s     pl_qin
          move.b    pt_stuf2(a5),d1
            beq.s   pl_stfok
          bsr.s     pl_qin
pl_stfok
          movea.l   d3,a2               ; SV_SER2C oder SV_SER1C zurck
sh_qleer
          move.l    $0C(a2),$08(a2)
          bra.s     ms_rts
pl_kypol
          move.b    d2,pt_kypol(a5)
          clr.b     pt_lstuf(a5)
          move.w    ms_shwert(a3),ms_downc(a3)

          moveq     #0,d4
          moveq     #0,d5
          bsr     pl_qout
            bne.s   sh_qleer
          move.b    d1,d4               ; vx
          bsr     pl_qout
            bne.s   sh_qleer
          move.b    d1,d5               ; vy
          bsr     pl_qout
            bne.s   sh_qleer
          add.b     d1,d4               ; +vx
          bsr     pl_qout
sh_qleex     bne   sh_qleer
          add.b     d1,d5               ; +vy
          ext.w     d4
          ext.l     d4
          ext.w     d5
          ext.l     d5
          neg.l     d5

          moveq     #0,d3
          move.w    ms_shwert(a3),d3    ; d3.msw = 0, d3.lsw = sh_wert
            beq   sh_ret

          moveq     #1,d0
          tst.w     d4
            bpl.s   sh_xpl
          moveq     #-1,d0
sh_xpl    moveq     #1,d1
          tst.w     d5
            bpl.s   sh_ypl
          moveq     #-1,d1
sh_ypl    move.w    d0,ms_sig_x(a3)     ; Vorzeichen x
          move.w    d1,ms_sig_y(a3)     ; Vorzeichen y

          divs      d3,d4
          move.w    d4,ms_anz_x(a3)     ; anz_x
          clr.w     d4
          divs      d3,d5
          move.w    d5,ms_anz_y(a3)     ; anz_y
          clr.w     d5

          swap      d4                  ; Rest x
          swap      d5                  ; Rest y
          move.l    d3,d2               ; sh_wert
          clr.l     ms_div_x(a3)
          tst.w     d4
            beq.s   sh_xnrest
          divu      d4,d3
          move.w    d3,ms_div_x(a3)     ; div_x
sh_xnrest
          tst.w     d5
            beq.s   sh_ynrest
          divu      d5,d2
          move.w    d2,ms_div_y(a3)     ; div_y
sh_ynrest
pl_exit
          rts

; Mouse scheduler routine
ms_schd
          tst.w     ms_downc(a3)
            ble.s   sh_ret
          subq.w    #1,ms_downc(a3)

          movea.l   ms_point(a3),a5
          move.w    ms_anz_x(a3),d0
            beq.s   sh_ty
          add.w     d0,pt_xinc(a5)                ; pt_xinc, pt_yinc setzen
          addq.w    #1,pt_xicnt(a5)
sh_ty     move.w    ms_anz_y(a3),d0
            beq.s   sh_nty
          addq.w    #1,pt_xicnt(a5)
          add.w     d0,pt_yinc(a5)
sh_nty
          subq.w    #1,ms_akt_x(a3)           ; akt_x
            bgt.s   sh_ydec
          move.w    ms_div_x(a3),ms_akt_x(a3) ; div_x -> akt_x
          move.w    ms_sig_x(a3),d0
          add.w     d0,pt_xinc(a5)
          addq.w    #1,pt_xicnt(a5)
sh_ydec
          subq.w    #1,ms_akt_y(a3)           ; akt_y
            bgt.s   sh_ret
          move.w    ms_div_y(a3),ms_akt_y(a3)
          move.w    ms_sig_y(a3),d0
          add.w     d0,pt_yinc(a5)
          addq.w    #1,pt_xicnt(a5)
sh_ret
          addq.w    #1,(a3)              ; ms_count $00 scheduler counter
          rts
; +++++++++++++++++++++++++++++++++++++++
conname   dc.w      13
          dc.b      'CON_2x2a0x0_4',0

sername   dc.w      5
          dc.b      'ser2i'
sernr     equ       sername+2+3
baudbyte  equ       sername+2+5
          dc.b      $04
serbaud   dc.w      1200
sernum    dc.w      $9C

; ----------------------------------------------------------------
;          bra.s     reset_ini
r_copyr   dc.w      24
          dc.b      'SER_RESET V1.00 1992Jo',$0A
          dc.b      '2401'
reset_ini
          lea       r_copyr(pc),a1
          bsr       ms_mtext
          lea       defproc(pc),a1
          movea.w   $110,a2   ; BP_INIT
          jmp       (a2)
defproc
          dc.w      2
          dc.w      serreset-*
          dc.b      9,'SER_RESET'
          dc.w      mouseres-*
          dc.b      8,'MS_RESET',0
          dc.w      0,1
          dc.w      baudrate-*
          dc.b      8,'BAUDRATE',0
          dc.w      0

;         BASIC - Procedure 'MS_RESET'
mouseres
          lea       sername(pc),a0
          bsr       ms_open             ; open SER2I
            beq.s   msreset             ; ok
          cmpi.b    #-9,d0              ; ERR_IU
            beq.s   msreset
          tst.l     d0
          rts
msreset
;          move.w    #1200,d1
          move.w    serbaud(pc),d1
          moveq     #$12,d0   ; MT_BAUD
          trap      #1

;         BASIC - Procedure 'SER_RESET'
serreset
          bsr       svbase    ; SV_BASE -> a5
          tst.l     $98(a5)   ; SV_SER1C
            bne.s   doreset
          tst.l     $9C(a5)   ; SV_SER2C
            beq.s   exit_rts
doreset
          move.w    sr,d6
          trap      #0
          ori.w     #$0700,sr           ; Interrupts aus
; status IPC
          moveq     #$7F,d3
tststat   lea       ipc_stat(pc),a3
          moveq     #$11,d0   ; MT_IPCOM
          trap      #1
          andi.b    #$0F,d1   ; keyboard oder sound aktiv
            beq.s   tstint
          bsr.s     wait
          dbf       d3,tststat
          bra.s     exit_nc
; no interrupts of IPC
tstint    moveq     #$7f,d3
nochmal
          move.b    $18021,d0
          cmpi.b    #$E0,d0   ; Interrupt-Routine aktiv ?
            beq.s   ist_ok
          bsr.s     wait
          dbf       d3,nochmal
          bra.s     exit_nc
; reset IPC
ist_ok    lea       ipc_reset(pc),a3
          moveq     #$11,d0   ; MT_IPCOM
          trap      #1

          moveq     #1,d0
          swap      d0                  ; $10000
          bsr.s     nudel               ; lnger als 20 ms !!!

          move.l    $98(a5),d0
            beq.s   queue2
          bsr.s     serclear            ; clear SER1 input/output queue
queue2    move.l    $9C(a5),d0
            beq.s   setbaud
          bsr.s     serclear            ; clear SER2 input/output queue
; Baudrate setzen
setbaud
          bsr.s     getbaud             ; Baudrate -> d1.w
          moveq     #$12,d0             ; MT_BAUD
          trap      #1

          tst.l     $98(a5)
            beq.s   open2
; open ser1
          lea       ipc_op1(pc),a3
          moveq     #$11,d0   ; MT_IPCOM
          trap      #1

open2     tst.l     $9C(a5)
            beq.s   exit_ok
; open ser2
          lea       ipc_op2(pc),a3
          moveq     #$11,d0   ; MT_IPCOM
          trap      #1
exit_ok
          move.w    d6,sr
exit_rts
          moveq     #0,d0     ; ERR_OK
          rts
;exit_iu
;          move.w    d6,sr
;          moveq     #-9,d0    ; ERR_IU
;          rts
exit_nc
          move.w    d6,sr
          moveq     #-1,d0    ; ERR_NC
          rts
; Interrupts ein, warten, Interrupts aus
wait
          move      d6,sr
          move.l    #$1000,d0
          bsr.s     nudel     ; im User-Mode nudeln
          trap      #0
          ori       #$0700,sr
          rts
nudel
n_loop    subq.l    #1,d0
            bgt.s   n_loop
          rts
serclear
          movea.l   d0,a2
          move.l    $0C(a2),$08(a2)             ; clear SER Input Queue
          move.l    $62+$0C(a2),$62+$08(a2)     ; clear SER Output Queue
          rts
confbaud
          moveq     #$07,d1
          and.b     baudbyte(pc),d1
          bra.s     allbaud
getbaud
          moveq     #$07,d1
          and.b     $A0(a5),d1          ; SV_TMODE, baud rate
allbaud   add.w     d1,d1
          move.w    baudliste(pc,d1.w),d1
          rts
svbase
          moveq     #0,d0     ; MT_INF
          trap      #1
          movea.l   a0,a5
          rts

;         BASIC - Function 'BAUDRATE'
baudrate
          bsr.s     svbase              ; SV_BASE -> a5
          bsr.s     getbaud             ; Baudrate -> d1.w
          subq.l    #2,$58(a6)          ; 2 bytes vom Basic-Stack klauen
          movea.l   $58(a6),a1          ; BV_RIP
          move.w    d1,0(a6,a1.l)       ; Rckgabe Parameter
          moveq     #3,d4               ; typ word integer
          bra.s     exit_rts

ipc_reset
          dc.b      $00       ; rset_cmd
          dc.b      $00       ; number of parameters
          dc.l      $00000000 ; no bits to send
          dc.b      %00000001 ; no reply
          dc.b      $FF       ; even
ipc_stat
          dc.b      $01       ; stat_cmd
          dc.b      $00       ; number of parameters
          dc.l      $00000000 ; no bits to send
          dc.b      %00000010 ; send 8 bits
          dc.b      $FF       ; even
ipc_op1
          dc.b      $02       ; ops2_cmd
          dc.b      $00       ; number of parameters
          dc.l      $00000000 ; no bits to send
          dc.b      %00000001 ; no reply
          dc.b      $FF       ; even
ipc_op2
          dc.b      $03       ; ops2_cmd
          dc.b      $00       ; number of parameters
          dc.l      $00000000 ; no bits to send
          dc.b      %00000001 ; no reply
          dc.b      $FF       ; even
baudliste
          dc.w      19200,9600,4800,2400,1200,600,300,75

postr
          jsr       confbaud(pc)
          lea       serbaud(pc),a5
          move.w    d1,(a5)
postret
          moveq     #$00,d1
          moveq     #$00,d0
          rts
postr2
          moveq    #$31,d0
          sub.b    sernr(pc),d0         ; 0= SER1, -1=SER2
          neg.b    d0                   ; 0        +1
          lsl.w    #2,d0                ; 0         4
          addi.w   #$98,d0              ; $98       $9C
          lea      sernum(pc),a5
          move.w   d0,(a5)
          bra.s    postret

;          include   flp3_pcmouse_confe_asm
;    end

; Texte deutsch
pinf_txt  dc.w      34
          dc.b      'Pointer Interface nicht vorhanden',$0A
mouse_txt dc.w      23
          dc.b      'Maus schon installiert',$0A,0

config
          dc.b      '<<>>'              ; Flag zum Abtrennen des Config-Blocks
          dc.b      '<<QCFX>>01'        ; Flag,level
          dc.w      7
          dc.b      'PCMouse',0         ; Name
          dc.w      4
          dc.l      version             ; Version
; Baudrate
          dc.b      4                   ; Item type: code
          dc.b      0                   ; Item selection Key
          dc.w      baudbyte-*          ; Pointer to item
          dc.w      0                   ;            pre-proc
          dc.w      postr-*             ;            post-proc
          dc.w      text0-*             ;            description
          dc.w      attr0-*             ;            attributes
; ser1 oder ser2
          dc.b      4                   ; Item type: code
          dc.b      0                   ; Item selection Key
          dc.w      sernr-*             ; Pointer to item
          dc.w      0                   ;            pre-proc
          dc.w      postr2-*            ;            post-proc
          dc.w      text1-*             ;            description
          dc.w      attr1-*             ;            attributes
          dc.w      -1                  ; End flag

text0     dc.w      8
          dc.b      'Baudrate'
attr0     dc.w      $0600
          dc.w      4
          dc.b      ' 300'
          dc.w      $0500
          dc.w      4
          dc.b      ' 600'
          dc.w      $0400
          dc.w      4
          dc.b      '1200'
          dc.w      $0300
          dc.w      4
          dc.b      '2400'
          dc.w      $0200
          dc.w      4
          dc.b      '4800'
          dc.w      $0100
          dc.w      4
          dc.b      '9600'
          dc.w      -1                  ; End flag

text1     dc.w      30
          dc.b      'Schnittstelle (ser1 oder ser2)'
attr1     dc.w      $3100
          dc.w      4
          dc.b      'ser1'
          dc.w      $3200
          dc.w      4
          dc.b      'ser2'
          dc.w      -1                  ; End flag
     end

